;; ----------------------------------------
;; Name:
;; Logic Disassembler Engine (LDE)
;; Version:
;; 1.0
;; Author:
;; 
;; Email:
;; logic_yan@hotmail.com
;; Describe:
;; It's base on ADE32. I recode it by masm, ADE32 is writed on C++
;; Compile Options:
;; ML.EXE /c /coff /Cp /nologo LDE.Asm
;; LIB.EXE LDE.obj
;; ----------------------------------------

;; ----------------------------------------
;; value definition
;; ----------------------------------------
C_ERROR         equ 0FFFFFFFFh
C_ADDR1         equ 00000001h
C_ADDR2         equ 00000002h
C_ADDR4         equ 00000004h
C_LOCK          equ 00000008h
C_67            equ 00000010h
C_66            equ 00000020h
C_REP           equ 00000040h
C_SEG           equ 00000080h
C_ANYPREFIX     equ (C_66+C_67+C_LOCK+C_REP+C_SEG)
C_DATA1         equ 00000100h
C_DATA2         equ 00000200h
C_DATA4         equ 00000400h
C_SIB           equ 00000800h
C_ADDR67        equ 00001000h
C_DATA66        equ 00002000h
C_MODRM         equ 00004000h
C_BAD           equ 00008000h
C_OPCODE2       equ 00010000h
C_REL           equ 00020000h
C_STOP          equ 00040000h
;; ----------------------------------------
;; structure definition
;; ----------------------------------------
DISASM_STRUCT struct
    disasm_defaddr      db  0           ; 00
    disasm_defdata      db  0           ; 01
    disasm_len          dd  0           ; 02 03 04 05
    disasm_flag         dd  0           ; 06 07 08 09
    disasm_addrsize     dd  0           ; 0A 0B 0C 0D
    disasm_datasize     dd  0           ; 0E 0F 10 11
    disasm_rep          db  0           ; 12
    disasm_seg          db  0           ; 13
    disasm_opcode       db  0           ; 14
    disasm_opcode2      db  0           ; 15
    disasm_modrm        db  0           ; 16
    disasm_sib          db  0           ; 17
    union
        disasm_addr_b   db 8 dup (0)    ; 18 19 1A 1B 1C 1D 1E 1F
        disasm_addr_w   dw 4 dup (0)
        disasm_addr_d   dd 2 dup (0)
        disasm_addr_c   db 8 dup (0)
        disasm_addr_s   dw 4 dup (0)
        disasm_addr_l   dd 2 dup (0)         
    ends
    union
        disasm_data_b   db 8 dup (0)    ; 20 21 22 23 24 25 26 27
        disasm_data_w   dw 4 dup (0)
        disasm_data_d   dd 2 dup (0)
        disasm_data_c   db 8 dup (0)
        disasm_data_s   dw 4 dup (0)
        disasm_data_l   dd 2 dup (0)          
    ends
DISASM_STRUCT ends

;; ----------------------------------------
;; function statement
;; ----------------------------------------
disasm proto opcode0 : LPVOID, diza : LPVOID
